<!-- Example widget for demonstration  -->
<script lang="ts">
	import { onMount } from 'svelte';
	import { streamerApi } from '$lib/requests/requests';
	import type { Streamer } from '$lib/api';
	import { teams } from '$lib/teams';

	let streamers: Streamer[] = [];

	let forms = {
		streamer_msg: {
			streamerid: '',
			message: ''
		},
		all_streamers_msg: {
			message: ''
		},
		team_msg: {
			team: '',
			message: ''
		},
		faux_don: {
			teamid: '',
			first_name: '',
			last_name: '',
			amount: 0
		},
		announcement: {
			message: ''
		}
	};

	onMount(async () => {
		let resp = await streamerApi().getStreamersStreamersGet();
		streamers = resp.data;
	});

	async function envoyerMessage(message: any, key: string) {
		let msg = {
			d: message,
			r: key
		};

		const requestBody = {
			msg: JSON.stringify(msg),
			key: key
		};

		let dev_url = 'http://localhost:8080/';
		let prod_url = './';

		let url = process.env.NODE_ENV === 'development' ? dev_url : prod_url;

		const response = await fetch(url, {
			method: 'POST',
			headers: {
				'Content-Type': 'application/json'
			},
			body: JSON.stringify(requestBody)
		});
	}

	function envoyerMessageUnStreamer(message: string, streamerID: string) {
		envoyerMessage(
			{ streamerID: streamerID, message: message },
			'streamers.' + streamerID + '.message'
		);
	}

	function envoyerMessageTous(message: string) {
		envoyerMessage({ message: message }, 'streamers.announcements');
	}

	function envoyerMessageGeneral(message: string) {
		envoyerMessage({ message: message }, 'announcements');
	}

	function envoyerMessageEquipe(message: string, team: string) {
		envoyerMessage({ teamID: team, message: message }, 'teams.' + team + '.message');
	}

	function envoyerFauxDon(teamid: string, first_name: string, last_name: string, amount: number) {
		let msg = {
			teamID: teamid,
			don: {
				first_name: first_name,
				last_name: last_name,
				amount: amount
			}
		};

		envoyerMessage(msg, 'teams.' + teamid + '.don');
	}
</script>

<div class="grid grid-cols-3 p-12 h-screen gap-4">
	<!-- Form to send message to a single streamer with a search -->
	<div class="col-span-1 bg-blue-300 p-4 rounded-md h-fit">
		<h1 class="text-2xl">Envoyer un message à un streamer</h1>
		<form
			on:submit|preventDefault={() =>
				envoyerMessageUnStreamer(forms.streamer_msg.message, forms.streamer_msg.streamerid)}
			class="grid grid-cols-1 space-y-4"
		>
			<label for="key">Streamer</label>
			<select
				class="border border-gray-300 rounded-md p-2"
				bind:value={forms.streamer_msg.streamerid}
				name="key"
				id="key"
				required
			>
				{#each streamers as streamer}
					<option value={streamer.id}>{streamer.name}</option>
				{/each}
			</select>
			<label for="message">Message</label>
			<textarea
				class="border border-gray-300 rounded-md"
				bind:value={forms.streamer_msg.message}
				name="message"
				id="message"
			></textarea>
			<button type="submit" class="bg-slate-500 text-white rounded-md p-2"> Envoyer </button>
		</form>
	</div>

	<!-- Form to send message to all streamers -->
	<div class="col-span-1 bg-blue-300 p-4 rounded-md h-fit">
		<h1 class="text-2xl">Envoyer un message à tous les streamers</h1>
		<form
			on:submit|preventDefault={() => envoyerMessageTous(forms.all_streamers_msg.message)}
			class="grid grid-cols-1 space-y-4"
		>
			<label for="message">Message</label>
			<textarea
				class="border border-gray-300 rounded-md"
				bind:value={forms.all_streamers_msg.message}
				name="message"
				id="message"
			></textarea>
			<button type="submit" class="bg-slate-500 text-white rounded-md p-2"> Envoyer </button>
		</form>
	</div>

	<!-- Form to send message to all streamers of a team -->
	<div class="col-span-1 bg-blue-300 p-4 rounded-md h-fit">
		<h1 class="text-2xl">Envoyer un message à une équipe</h1>
		<form
			on:submit|preventDefault={() =>
				envoyerMessageEquipe(forms.team_msg.message, forms.team_msg.team)}
			class="grid grid-cols-1 space-y-4"
		>
			<label for="key">Équipe</label>
			<select
				class="border border-gray-300 rounded-md p-2"
				bind:value={forms.team_msg.team}
				name="key"
				id="key"
				required
			>
				{#each teams as team, i}
					<option value={i}>{team.name}</option>
				{/each}
			</select>
			<label for="message">Message</label>
			<textarea
				class="border border-gray-300 rounded-md"
				bind:value={forms.team_msg.message}
				name="message"
				id="message"
			></textarea>
			<button type="submit" class="bg-slate-500 text-white rounded-md p-2"> Envoyer </button>
		</form>
	</div>

	<!-- Form to send message to all streamers -->
	<div class="col-span-1 bg-blue-300 p-4 rounded-md h-fit">
		<h1 class="text-2xl">Envoyer une annonce</h1>
		<form
			on:submit|preventDefault={() => envoyerMessageGeneral(forms.announcement.message)}
			class="grid grid-cols-1 space-y-4"
		>
			<label for="message">Message</label>
			<textarea
				class="border border-gray-300 rounded-md"
				bind:value={forms.announcement.message}
				name="message"
				id="message"
			></textarea>
			<button type="submit" class="bg-slate-500 text-white rounded-md p-2"> Envoyer </button>
		</form>
	</div>

	<!-- Form to send a fake donation to a team -->
	<div class="col-span-1 bg-blue-300 p-4 rounded-md h-fit">
		<h1 class="text-2xl">Envoyer un faux don à une équipe</h1>
		<form
			on:submit|preventDefault={() =>
				envoyerFauxDon(
					forms.faux_don.teamid,
					forms.faux_don.first_name,
					forms.faux_don.last_name,
					forms.faux_don.amount
				)}
			class="grid grid-cols-1 space-y-4"
		>
			<label for="key">Équipe</label>
			<select
				class="border border-gray-300 rounded-md p-2"
				bind:value={forms.faux_don.teamid}
				name="key"
				id="key"
				required
			>
				{#each teams as team, i}
					<option value={i}>{team.name}</option>
				{/each}
			</select>
			<label for="first_name">Prénom</label>
			<input
				class="border border-gray-300 rounded-md p-2"
				bind:value={forms.faux_don.first_name}
				type="text"
				name="first_name"
				id="first_name"
				required
			/>
			<label for="last_name">Nom</label>
			<input
				class="border border-gray-300 rounded-md p-2"
				bind:value={forms.faux_don.last_name}
				type="text"
				name="last_name"
				id="last_name"
				required
			/>
			<label for="amount">Montant</label>
			<input
				class="border border-gray-300 rounded-md p-2"
				bind:value={forms.faux_don.amount}
				type="number"
				name="amount"
				id="amount"
				required
			/>
			<button type="submit" class="bg-slate-500 text-white rounded-md p-2"> Envoyer </button>
		</form>
	</div>
</div>

<style>
	:global(body) {
		background-color: #f3f4f6;
	}
</style>
